Index: src/project.c
===================================================================
--- src/project.c	(revision 2039)
+++ src/project.c	(working copy)
@@ -514,174 +529,174 @@
  * Returns: FALSE if the user needs to change any data. */
 static gboolean update_config(const PropertyDialogElements *e)
 {
-	const gchar *name, *file_name, *base_path;
-	gchar *locale_filename;
-	gint name_len;
-	gboolean new_project = FALSE;
-	GeanyProject *p;
+    const gchar *name, *file_name, *base_path;
+    gchar *locale_filename;
+    gint name_len;
+    gboolean new_project = FALSE;
+    GeanyProject *p;
 
-	g_return_val_if_fail(e != NULL, TRUE);
+    g_return_val_if_fail(e != NULL, TRUE);
 
-	name = gtk_entry_get_text(GTK_ENTRY(e->name));
-	name_len = strlen(name);
-	if (name_len == 0)
-	{
-		SHOW_ERR(_("The specified project name is too short."));
-		gtk_widget_grab_focus(e->name);
-		return FALSE;
-	}
-	else if (name_len > MAX_NAME_LEN)
-	{
-		SHOW_ERR1(_("The specified project name is too long (max. %d characters)."), MAX_NAME_LEN);
-		gtk_widget_grab_focus(e->name);
-		return FALSE;
-	}
+    name = gtk_entry_get_text(GTK_ENTRY(e->name));
+    name_len = strlen(name);
+    if (name_len == 0)
+    {
+        SHOW_ERR(_("The specified project name is too short."));
+        gtk_widget_grab_focus(e->name);
+        return FALSE;
+    }
+    else if (name_len > MAX_NAME_LEN)
+    {
+        SHOW_ERR1(_("The specified project name is too long (max. %d characters)."), MAX_NAME_LEN);
+        gtk_widget_grab_focus(e->name);
+        return FALSE;
+    }
 
-	file_name = gtk_entry_get_text(GTK_ENTRY(e->file_name));
-	if (strlen(file_name) == 0)
-	{
-		SHOW_ERR(_("You have specified an invalid project filename."));
-		gtk_widget_grab_focus(e->file_name);
-		return FALSE;
-	}
+    file_name = gtk_entry_get_text(GTK_ENTRY(e->file_name));
+    if (strlen(file_name) == 0)
+    {
+        SHOW_ERR(_("You have specified an invalid project filename."));
+        gtk_widget_grab_focus(e->file_name);
+        return FALSE;
+    }
 
-	// finally test whether the given project file can be written
-	locale_filename = utils_get_locale_from_utf8(file_name);
-	if (utils_write_file(file_name, "") != 0)
-	{
-		SHOW_ERR(_("Project file could not be written."));
-		gtk_widget_grab_focus(e->file_name);
-		return FALSE;
-	}
+    // finally test whether the given project file can be written
+    locale_filename = utils_get_locale_from_utf8(file_name);
+    if (utils_write_file(file_name, "") != 0)
+    {
+        SHOW_ERR(_("Project file could not be written."));
+        gtk_widget_grab_focus(e->file_name);
+        return FALSE;
+    }
 
-	base_path = gtk_entry_get_text(GTK_ENTRY(e->base_path));
-	if (NZV(base_path))
-	{	// check whether the given directory actually exists
-		gchar *locale_path = utils_get_locale_from_utf8(base_path);
+    base_path = gtk_entry_get_text(GTK_ENTRY(e->base_path));
+    if (NZV(base_path))
+    {   // check whether the given directory actually exists
+        gchar *locale_path = utils_get_locale_from_utf8(base_path);
 
-		if (! g_path_is_absolute(locale_path))
-		{	// relative base path, so add base dir of project file name
-			gchar *dir = g_path_get_dirname(locale_filename);
-			setptr(locale_path, g_strconcat(dir, G_DIR_SEPARATOR_S, locale_path, NULL));
-			g_free(dir);
-		}
+        if (! g_path_is_absolute(locale_path))
+        {   // relative base path, so add base dir of project file name
+            gchar *dir = g_path_get_dirname(locale_filename);
+            setptr(locale_path, g_strconcat(dir, G_DIR_SEPARATOR_S, locale_path, NULL));
+            g_free(dir);
+        }
 
-		if (! g_file_test(locale_path, G_FILE_TEST_IS_DIR))
-		{
-			if (dialogs_show_question_full(NULL, GTK_STOCK_OK, GTK_STOCK_CANCEL,
-				_("Create the project's base path directory?"),
-				_("The path \"%s\" does not exist."),
-				base_path))
-			{
-				utils_mkdir(locale_path, TRUE);
-			}
-			else
-			{
-				g_free(locale_path);
-				gtk_widget_grab_focus(e->base_path);
-				return FALSE;
-			}
-		}
-		g_free(locale_path);
-	}
-	g_free(locale_filename);
+        if (! g_file_test(locale_path, G_FILE_TEST_IS_DIR))
+        {
+            if (dialogs_show_question_full(NULL, GTK_STOCK_OK, GTK_STOCK_CANCEL,
+                _("Create the project's base path directory?"),
+                _("The path \"%s\" does not exist."),
+                base_path))
+            {
+                utils_mkdir(locale_path, TRUE);
+            }
+            else
+            {
+                g_free(locale_path);
+                gtk_widget_grab_focus(e->base_path);
+                return FALSE;
+            }
+        }
+        g_free(locale_path);
+    }
+    g_free(locale_filename);
 
-	if (app->project == NULL)
-	{
-		app->project = g_new0(GeanyProject, 1);
-		new_project = TRUE;
-	}
-	p = app->project;
+    if (app->project == NULL)
+    {
+        app->project = g_new0(GeanyProject, 1);
+        new_project = TRUE;
+    }
+    p = app->project;
 
-	if (p->name != NULL) g_free(p->name);
-	p->name = g_strdup(name);
+    if (p->name != NULL) g_free(p->name);
+    p->name = g_strdup(name);
 
-	if (p->file_name != NULL) g_free(p->file_name);
-	p->file_name = g_strdup(file_name);
+    if (p->file_name != NULL) g_free(p->file_name);
+    p->file_name = g_strdup(file_name);
 
-	if (p->base_path != NULL) g_free(p->base_path);
-	p->base_path = g_strdup(NZV(base_path) ? base_path : "./"); // use "." if base_path is empty
+    if (p->base_path != NULL) g_free(p->base_path);
+    p->base_path = g_strdup(NZV(base_path) ? base_path : "./"); // use "." if base_path is empty
 
-	if (! new_project)	// save properties specific fields
-	{
-		GtkTextIter start, end;
-		//gchar *tmp;
-		GtkTextBuffer *buffer;
+    if (! new_project)  // save properties specific fields
+    {
+        GtkTextIter start, end;
+        //gchar *tmp;
+        GtkTextBuffer *buffer;
 
-		if (p->run_cmd != NULL) g_free(p->run_cmd);
-		p->run_cmd = g_strdup(gtk_entry_get_text(GTK_ENTRY(e->run_cmd)));
+        if (p->run_cmd != NULL) g_free(p->run_cmd);
+        p->run_cmd = g_strdup(gtk_entry_get_text(GTK_ENTRY(e->run_cmd)));
 
-		// get and set the project description
-		buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(e->description));
-		gtk_text_buffer_get_start_iter(buffer, &start);
-		gtk_text_buffer_get_end_iter(buffer, &end);
-		g_free(p->description);
-		p->description = gtk_text_buffer_get_text(buffer, &start, &end, FALSE);
+        // get and set the project description
+        buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(e->description));
+        gtk_text_buffer_get_start_iter(buffer, &start);
+        gtk_text_buffer_get_end_iter(buffer, &end);
+        g_free(p->description);
+        p->description = gtk_text_buffer_get_text(buffer, &start, &end, FALSE);
 
 #if 0
-		// get and set the project file patterns
-		buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(e->patterns));
-		gtk_text_buffer_get_start_iter(buffer, &start);
-		gtk_text_buffer_get_end_iter(buffer, &end);
-		tmp = gtk_text_buffer_get_text(buffer, &start, &end, FALSE);
-		g_strfreev(p->file_patterns);
-		p->file_patterns = g_strsplit(tmp, "\n", -1);
-		g_free(tmp);
+        // get and set the project file patterns
+        buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(e->patterns));
+        gtk_text_buffer_get_start_iter(buffer, &start);
+        gtk_text_buffer_get_end_iter(buffer, &end);
+        tmp = gtk_text_buffer_get_text(buffer, &start, &end, FALSE);
+        g_strfreev(p->file_patterns);
+        p->file_patterns = g_strsplit(tmp, "\n", -1);
+        g_free(tmp);
 #endif
-	}
-	write_config();
-	if (new_project)
-		ui_set_statusbar(TRUE, _("Project \"%s\" created."), p->name);
-	else
-		ui_set_statusbar(TRUE, _("Project \"%s\" saved."), p->name);
+    }
+    write_config();
+    if (new_project)
+        ui_set_statusbar(TRUE, _("Project \"%s\" created."), p->name);
+    else
+        ui_set_statusbar(TRUE, _("Project \"%s\" saved."), p->name);
 
-	return TRUE;
+    return TRUE;
 }
 
 
 #ifndef G_OS_WIN32
 static void run_dialog(GtkWidget *dialog, GtkWidget *entry)
 {
-	// set filename in the file chooser dialog
-	const gchar *utf8_filename = gtk_entry_get_text(GTK_ENTRY(entry));
-	gchar *locale_filename = utils_get_locale_from_utf8(utf8_filename);
+    // set filename in the file chooser dialog
+    const gchar *utf8_filename = gtk_entry_get_text(GTK_ENTRY(entry));
+    gchar *locale_filename = utils_get_locale_from_utf8(utf8_filename);
 
-	if (g_path_is_absolute(locale_filename))
-	{
-		if (g_file_test(locale_filename, G_FILE_TEST_EXISTS))
-			gtk_file_chooser_set_filename(GTK_FILE_CHOOSER(dialog), utf8_filename);
-		else // if the file doesn't yet exist, use at least the current directory
-		{
-			gchar *locale_dir = g_path_get_dirname(locale_filename);
-			gchar *name = g_path_get_basename(utf8_filename);
+    if (g_path_is_absolute(locale_filename))
+    {
+        if (g_file_test(locale_filename, G_FILE_TEST_EXISTS))
+            gtk_file_chooser_set_filename(GTK_FILE_CHOOSER(dialog), utf8_filename);
+        else // if the file doesn't yet exist, use at least the current directory
+        {
+            gchar *locale_dir = g_path_get_dirname(locale_filename);
+            gchar *name = g_path_get_basename(utf8_filename);
 
-			if (g_file_test(locale_dir, G_FILE_TEST_EXISTS))
-				gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(dialog), locale_dir);
-			gtk_file_chooser_set_current_name(GTK_FILE_CHOOSER(dialog), name);
+            if (g_file_test(locale_dir, G_FILE_TEST_EXISTS))
+                gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(dialog), locale_dir);
+            gtk_file_chooser_set_current_name(GTK_FILE_CHOOSER(dialog), name);
 
-			g_free(name);
-			g_free(locale_dir);
-		}
-	}
-	else
-	if (gtk_file_chooser_get_action(GTK_FILE_CHOOSER(dialog)) != GTK_FILE_CHOOSER_ACTION_OPEN)
-	{
-		gtk_file_chooser_set_current_name(GTK_FILE_CHOOSER(dialog), utf8_filename);
-	}
-	g_free(locale_filename);
+            g_free(name);
+            g_free(locale_dir);
+        }
+    }
+    else
+    if (gtk_file_chooser_get_action(GTK_FILE_CHOOSER(dialog)) != GTK_FILE_CHOOSER_ACTION_OPEN)
+    {
+        gtk_file_chooser_set_current_name(GTK_FILE_CHOOSER(dialog), utf8_filename);
+    }
+    g_free(locale_filename);
 
-	// run it
-	if (gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_ACCEPT)
-	{
-		gchar *filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
-		gchar *tmp_utf8_filename = utils_get_utf8_from_locale(filename);
+    // run it
+    if (gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_ACCEPT)
+    {
+        gchar *filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
+        gchar *tmp_utf8_filename = utils_get_utf8_from_locale(filename);
 
-		gtk_entry_set_text(GTK_ENTRY(entry), tmp_utf8_filename);
+        gtk_entry_set_text(GTK_ENTRY(entry), tmp_utf8_filename);
 
-		g_free(tmp_utf8_filename);
-		g_free(filename);
-	}
-	gtk_widget_destroy(dialog);
+        g_free(tmp_utf8_filename);
+        g_free(filename);
+    }
+    gtk_widget_destroy(dialog);
 }
 #endif
 
@@ -689,28 +704,28 @@
 static void on_file_save_button_clicked(GtkButton *button, GtkWidget *entry)
 {
 #ifdef G_OS_WIN32
-	gchar *path = win32_show_project_open_dialog(_("Choose Project Filename"),
-						gtk_entry_get_text(GTK_ENTRY(entry)), TRUE);
-	if (path != NULL)
-	{
-		gtk_entry_set_text(GTK_ENTRY(entry), path);
-		g_free(path);
-	}
+    gchar *path = win32_show_project_open_dialog(_("Choose Project Filename"),
+                        gtk_entry_get_text(GTK_ENTRY(entry)), TRUE);
+    if (path != NULL)
+    {
+        gtk_entry_set_text(GTK_ENTRY(entry), path);
+        g_free(path);
+    }
 #else
-	GtkWidget *dialog;
+    GtkWidget *dialog;
 
-	// initialise the dialog
-	dialog = gtk_file_chooser_dialog_new(_("Choose Project Filename"), NULL,
-					GTK_FILE_CHOOSER_ACTION_SAVE,
-					GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
-					GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT, NULL);
-	gtk_widget_set_name(dialog, "GeanyDialogProject");
-	gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog), TRUE);
-	gtk_window_set_skip_taskbar_hint(GTK_WINDOW(dialog), TRUE);
-	gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
-	gtk_dialog_set_default_response(GTK_DIALOG(dialog), GTK_RESPONSE_ACCEPT);
+    // initialise the dialog
+    dialog = gtk_file_chooser_dialog_new(_("Choose Project Filename"), NULL,
+                    GTK_FILE_CHOOSER_ACTION_SAVE,
+                    GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
+                    GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT, NULL);
+    gtk_widget_set_name(dialog, "GeanyDialogProject");
+    gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog), TRUE);
+    gtk_window_set_skip_taskbar_hint(GTK_WINDOW(dialog), TRUE);
+    gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
+    gtk_dialog_set_default_response(GTK_DIALOG(dialog), GTK_RESPONSE_ACCEPT);
 
-	run_dialog(dialog, entry);
+    run_dialog(dialog, entry);
 #endif
 }
 
@@ -718,28 +733,28 @@
 static void on_file_open_button_clicked(GtkButton *button, GtkWidget *entry)
 {
 #ifdef G_OS_WIN32
-	gchar *path = win32_show_project_open_dialog(_("Choose Project Run Command"),
-						gtk_entry_get_text(GTK_ENTRY(entry)), FALSE);
-	if (path != NULL)
-	{
-		gtk_entry_set_text(GTK_ENTRY(entry), path);
-		g_free(path);
-	}
+    gchar *path = win32_show_project_open_dialog(_("Choose Project Run Command"),
+                        gtk_entry_get_text(GTK_ENTRY(entry)), FALSE);
+    if (path != NULL)
+    {
+        gtk_entry_set_text(GTK_ENTRY(entry), path);
+        g_free(path);
+    }
 #else
-	GtkWidget *dialog;
+    GtkWidget *dialog;
 
-	// initialise the dialog
-	dialog = gtk_file_chooser_dialog_new(_("Choose Project Run Command"), NULL,
-					GTK_FILE_CHOOSER_ACTION_OPEN,
-					GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
-					GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);
-	gtk_widget_set_name(dialog, "GeanyDialog");
-	gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog), TRUE);
-	gtk_window_set_skip_taskbar_hint(GTK_WINDOW(dialog), TRUE);
-	gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
-	gtk_dialog_set_default_response(GTK_DIALOG(dialog), GTK_RESPONSE_ACCEPT);
+    // initialise the dialog
+    dialog = gtk_file_chooser_dialog_new(_("Choose Project Run Command"), NULL,
+                    GTK_FILE_CHOOSER_ACTION_OPEN,
+                    GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
+                    GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);
+    gtk_widget_set_name(dialog, "GeanyDialog");
+    gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog), TRUE);
+    gtk_window_set_skip_taskbar_hint(GTK_WINDOW(dialog), TRUE);
+    gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
+    gtk_dialog_set_default_response(GTK_DIALOG(dialog), GTK_RESPONSE_ACCEPT);
 
-	run_dialog(dialog, entry);
+    run_dialog(dialog, entry);
 #endif
 }
 
@@ -747,62 +762,62 @@
 /* sets the project base path and the project file name according to the project name */
 static void on_name_entry_changed(GtkEditable *editable, PropertyDialogElements *e)
 {
-	gchar *base_path;
-	gchar *file_name;
-	gchar *name;
-	const gchar *project_dir = local_prefs.project_file_path;
+    gchar *base_path;
+    gchar *file_name;
+    gchar *name;
+    const gchar *project_dir = local_prefs.project_file_path;
 
-	if (entries_modified)
-		return;
+    if (entries_modified)
+        return;
 
-	name = gtk_editable_get_chars(editable, 0, -1);
-	if (name != NULL && strlen(name) > 0)
-	{
-		base_path = g_strconcat(project_dir, G_DIR_SEPARATOR_S,
-			name, G_DIR_SEPARATOR_S, NULL);
-		file_name = g_strconcat(project_dir, G_DIR_SEPARATOR_S,
-			name, "." GEANY_PROJECT_EXT, NULL);
-	}
-	else
-	{
-		base_path = g_strconcat(project_dir, G_DIR_SEPARATOR_S, NULL);
-		file_name = g_strconcat(project_dir, G_DIR_SEPARATOR_S, NULL);
-	}
-	g_free(name);
+    name = gtk_editable_get_chars(editable, 0, -1);
+    if (name != NULL && strlen(name) > 0)
+    {
+        base_path = g_strconcat(project_dir, G_DIR_SEPARATOR_S,
+            name, G_DIR_SEPARATOR_S, NULL);
+        file_name = g_strconcat(project_dir, G_DIR_SEPARATOR_S,
+            name, "." GEANY_PROJECT_EXT, NULL);
+    }
+    else
+    {
+        base_path = g_strconcat(project_dir, G_DIR_SEPARATOR_S, NULL);
+        file_name = g_strconcat(project_dir, G_DIR_SEPARATOR_S, NULL);
+    }
+    g_free(name);
 
-	gtk_entry_set_text(GTK_ENTRY(e->base_path), base_path);
-	gtk_entry_set_text(GTK_ENTRY(e->file_name), file_name);
+    gtk_entry_set_text(GTK_ENTRY(e->base_path), base_path);
+    gtk_entry_set_text(GTK_ENTRY(e->file_name), file_name);
 
-	entries_modified = FALSE;
+    entries_modified = FALSE;
 
-	g_free(base_path);
-	g_free(file_name);
+    g_free(base_path);
+    g_free(file_name);
 }
 
 
 static void on_entries_changed(GtkEditable *editable, PropertyDialogElements *e)
 {
-	entries_modified = TRUE;
+    entries_modified = TRUE;
 }
 
 
 gboolean project_load_file(const gchar *locale_file_name)
 {
-	g_return_val_if_fail(locale_file_name != NULL, FALSE);
+    g_return_val_if_fail(locale_file_name != NULL, FALSE);
 
-	if (load_config(locale_file_name))
-	{
-		ui_set_statusbar(TRUE, _("Project \"%s\" opened."), app->project->name);
-		return TRUE;
-	}
-	else
-	{
-		gchar *utf8_filename = utils_get_utf8_from_locale(locale_file_name);
+    if (load_config(locale_file_name))
+    {
+        ui_set_statusbar(TRUE, _("Project \"%s\" opened."), app->project->name);
+        return TRUE;
+    }
+    else
+    {
+        gchar *utf8_filename = utils_get_utf8_from_locale(locale_file_name);
 
-		ui_set_statusbar(TRUE, _("Project file \"%s\" could not be loaded."), utf8_filename);
-		g_free(utf8_filename);
-	}
-	return FALSE;
+        ui_set_statusbar(TRUE, _("Project file \"%s\" could not be loaded."), utf8_filename);
+        g_free(utf8_filename);
+    }
+    return FALSE;
 }
 
 
@@ -812,73 +827,79 @@
  * The filename is expected in the locale encoding. */
 static gboolean load_config(const gchar *filename)
 {
-	GKeyFile *config;
-	GeanyProject *p;
+    GKeyFile *config;
+    GeanyProject *p;
 
-	// there should not be an open project
-	g_return_val_if_fail(app->project == NULL && filename != NULL, FALSE);
+    // there should not be an open project
+    g_return_val_if_fail(app->project == NULL && filename != NULL, FALSE);
 
-	config = g_key_file_new();
-	if (! g_key_file_load_from_file(config, filename, G_KEY_FILE_KEEP_COMMENTS, NULL))
-	{
-		g_key_file_free(config);
-		return FALSE;
-	}
+    config = g_key_file_new();
+    if (! g_key_file_load_from_file(config, filename, G_KEY_FILE_KEEP_COMMENTS, NULL))
+    {
+        g_key_file_free(config);
+        return FALSE;
+    }
 
-	p = app->project = g_new0(GeanyProject, 1);
+    p = app->project = g_new0(GeanyProject, 1);
 
-	p->name = utils_get_setting_string(config, "project", "name", GEANY_STRING_UNTITLED);
-	p->description = utils_get_setting_string(config, "project", "description", "");
-	p->file_name = utils_get_utf8_from_locale(filename);
-	p->base_path = utils_get_setting_string(config, "project", "base_path", "");
-	p->run_cmd = utils_get_setting_string(config, "project", "run_cmd", "");
-	p->file_patterns = g_key_file_get_string_list(config, "project", "file_patterns", NULL, NULL);
+    p->name = utils_get_setting_string(config, "project", "name", GEANY_STRING_UNTITLED);
+    p->description = utils_get_setting_string(config, "project", "description", "");
+    p->file_name = utils_get_utf8_from_locale(filename);
+    p->base_path = utils_get_setting_string(config, "project", "base_path", "");
+    p->run_cmd = utils_get_setting_string(config, "project", "run_cmd", "");
+    p->file_patterns = g_key_file_get_string_list(config, "project", "file_patterns", NULL, NULL);
 
-	g_key_file_free(config);
+    // fetch session files too
+    load_session_files(config);
 
-	update_ui();
-	return TRUE;
+    g_key_file_free(config);
+
+    update_ui();
+    return TRUE;
 }
 
 
 // Returns: TRUE if project file was written successfully.
 static gboolean write_config()
 {
-	GeanyProject *p;
-	GKeyFile *config;
-	gchar *filename;
-	gchar *data;
-	gboolean ret = FALSE;
+    GeanyProject *p;
+    GKeyFile *config;
+    gchar *filename;
+    gchar *data;
+    gboolean ret = FALSE;
 
-	g_return_val_if_fail(app->project != NULL, FALSE);
+    g_return_val_if_fail(app->project != NULL, FALSE);
 
-	p = app->project;
+    p = app->project;
 
-	config = g_key_file_new();
-	// try to load an existing config to keep manually added comments
-	filename = utils_get_locale_from_utf8(p->file_name);
-	g_key_file_load_from_file(config, filename, G_KEY_FILE_KEEP_COMMENTS, NULL);
+    config = g_key_file_new();
+    // try to load an existing config to keep manually added comments
+    filename = utils_get_locale_from_utf8(p->file_name);
+    g_key_file_load_from_file(config, filename, G_KEY_FILE_KEEP_COMMENTS, NULL);
 
-	g_key_file_set_string(config, "project", "name", p->name);
-	g_key_file_set_string(config, "project", "base_path", p->base_path);
+    g_key_file_set_string(config, "project", "name", p->name);
+    g_key_file_set_string(config, "project", "base_path", p->base_path);
 
-	if (p->description)
-		g_key_file_set_string(config, "project", "description", p->description);
-	if (p->run_cmd)
-		g_key_file_set_string(config, "project", "run_cmd", p->run_cmd);
-	if (p->file_patterns)
-		g_key_file_set_string_list(config, "project", "file_patterns",
-			(const gchar**) p->file_patterns, g_strv_length(p->file_patterns));
+    if (p->description)
+        g_key_file_set_string(config, "project", "description", p->description);
+    if (p->run_cmd)
+        g_key_file_set_string(config, "project", "run_cmd", p->run_cmd);
+    if (p->file_patterns)
+        g_key_file_set_string_list(config, "project", "file_patterns",
+            (const gchar**) p->file_patterns, g_strv_length(p->file_patterns));
 
-	// write the file
-	data = g_key_file_to_data(config, NULL, NULL);
-	ret = (utils_write_file(filename, data) == 0);
+    // Store the session files into the project too
+    save_session_files(config);
 
-	g_free(data);
-	g_free(filename);
-	g_key_file_free(config);
+    // write the file
+    data = g_key_file_to_data(config, NULL, NULL);
+    ret = (utils_write_file(filename, data) == 0);
 
-	return ret;
+    g_free(data);
+    g_free(filename);
+    g_key_file_free(config);
+
+    return ret;
 }
 
 
@@ -889,79 +910,78 @@
  * The returned string should be freed when no longer needed. */
 gchar *project_get_make_dir()
 {
-	if (app->project != NULL && NZV(app->project->base_path))
-	{
-		if (g_path_is_absolute(app->project->base_path))
-			return g_strdup(app->project->base_path);
-		else
-		{	// build base_path out of project file name's dir and base_path
-			gchar *path;
-			gchar *dir = g_path_get_dirname(app->project->file_name);
+    if (app->project != NULL && NZV(app->project->base_path))
+    {
+        if (g_path_is_absolute(app->project->base_path))
+            return g_strdup(app->project->base_path);
+        else
+        {   // build base_path out of project file name's dir and base_path
+            gchar *path;
+            gchar *dir = g_path_get_dirname(app->project->file_name);
 
-			path = g_strconcat(dir, G_DIR_SEPARATOR_S, app->project->base_path, NULL);
-			g_free(dir);
-			return path;
-		}
-	}
-	else
-		return NULL;
+            path = g_strconcat(dir, G_DIR_SEPARATOR_S, app->project->base_path, NULL);
+            g_free(dir);
+            return path;
+        }
+    }
+    else
+        return NULL;
 }
 
 
 void project_save_prefs(GKeyFile *config)
 {
-	GeanyProject *project = app->project;
+    GeanyProject *project = app->project;
 
-	if (cl_options.load_session)
-	{
-		gchar *utf8_filename = (project == NULL) ? "" : project->file_name;
+    if (cl_options.load_session)
+    {
+        gchar *utf8_filename = (project == NULL) ? "" : project->file_name;
 
-		g_key_file_set_string(config, "project", "session_file", utf8_filename);
-	}
-	g_key_file_set_string(config, "project", "project_file_path",
-		NVL(local_prefs.project_file_path, ""));
+        g_key_file_set_string(config, "project", "session_file", utf8_filename);
+    }
+    g_key_file_set_string(config, "project", "project_file_path",
+        NVL(local_prefs.project_file_path, ""));
 }
 
 
 void project_load_prefs(GKeyFile *config)
 {
-	if (cl_options.load_session)
-	{
-		g_return_if_fail(project_prefs.session_file == NULL);
-		project_prefs.session_file = utils_get_setting_string(config, "project",
-			"session_file", "");
-	}
-	local_prefs.project_file_path = utils_get_setting_string(config, "project",
-		"project_file_path", NULL);
-	if (local_prefs.project_file_path == NULL)
-	{
-		local_prefs.project_file_path = g_strconcat(GEANY_HOME_DIR,
-			G_DIR_SEPARATOR_S, PROJECT_DIR, NULL);
-	}
+    if (cl_options.load_session)
+    {
+        g_return_if_fail(project_prefs.session_file == NULL);
+        project_prefs.session_file = utils_get_setting_string(config, "project",
+            "session_file", "");
+    }
+    local_prefs.project_file_path = utils_get_setting_string(config, "project",
+        "project_file_path", NULL);
+    if (local_prefs.project_file_path == NULL)
+    {
+        local_prefs.project_file_path = g_strconcat(GEANY_HOME_DIR,
+            G_DIR_SEPARATOR_S, PROJECT_DIR, NULL);
+    }
 }
 
-
 /* Initialize project-related preferences in the Preferences dialog. */
 void project_setup_prefs()
 {
-	GtkWidget *path_entry = lookup_widget(ui_widgets.prefs_dialog, "project_file_path_entry");
-	GtkWidget *path_btn = lookup_widget(ui_widgets.prefs_dialog, "project_file_path_button");
+    GtkWidget *path_entry = lookup_widget(ui_widgets.prefs_dialog, "project_file_path_entry");
+    GtkWidget *path_btn = lookup_widget(ui_widgets.prefs_dialog, "project_file_path_button");
 
-	g_return_if_fail(local_prefs.project_file_path != NULL);
-	gtk_entry_set_text(GTK_ENTRY(path_entry), local_prefs.project_file_path);
-	ui_setup_open_button_callback(path_btn, NULL,
-		GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, GTK_ENTRY(path_entry));
+    g_return_if_fail(local_prefs.project_file_path != NULL);
+    gtk_entry_set_text(GTK_ENTRY(path_entry), local_prefs.project_file_path);
+    ui_setup_open_button_callback(path_btn, NULL,
+        GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, GTK_ENTRY(path_entry));
 }
 
 
 /* Update project-related preferences after using the Preferences dialog. */
 void project_apply_prefs()
 {
-	GtkWidget *path_entry = lookup_widget(ui_widgets.prefs_dialog, "project_file_path_entry");
-	const gchar *str;
+    GtkWidget *path_entry = lookup_widget(ui_widgets.prefs_dialog, "project_file_path_entry");
+    const gchar *str;
 
-	str = gtk_entry_get_text(GTK_ENTRY(path_entry));
-	setptr(local_prefs.project_file_path, g_strdup(str));
+    str = gtk_entry_get_text(GTK_ENTRY(path_entry));
+    setptr(local_prefs.project_file_path, g_strdup(str));
 }
 
 
Index: src/project.h
===================================================================
--- src/project.h	(revision 2039)
+++ src/project.h	(working copy)
@@ -29,21 +29,21 @@
 /* structure for representing a project. */
 struct _GeanyProject
 {
-	gchar *name; 			// the name of the project
-	gchar *description; 	// short description of the project
+    gchar *name;            // the name of the project
+    gchar *description;     // short description of the project
 
-	gchar *file_name; 		// where the project file is stored (in UTF-8)
+    gchar *file_name;       // where the project file is stored (in UTF-8)
 
-	gchar *base_path;		// base path of the project directory (in UTF-8, maybe relative)
-	gchar *run_cmd; 		// project run command (in UTF-8)
-	// ...					// fields for build process(run arguments and so on) should be added
+    gchar *base_path;       // base path of the project directory (in UTF-8, maybe relative)
+    gchar *run_cmd;         // project run command (in UTF-8)
+    // ...                  // fields for build process(run arguments and so on) should be added
 
-	gchar **file_patterns;	// array of filename extension patterns
+    gchar **file_patterns;  // array of filename extension patterns
 };
 
 typedef struct
 {
-	gchar *session_file;
+    gchar *session_file;
 } ProjectPrefs;
 
 extern ProjectPrefs project_prefs;
@@ -53,6 +53,8 @@
 
 void project_open();
 
+void project_save();
+
 void project_close();
 
 void project_properties();
